﻿
#include "cuda_runtime.h"
#include "device_launch_parameters.h"

#include <stdio.h>
#include  <Windows.h>



#include "bila.cuh" 

#include <opencv2/opencv.hpp>


#include "../cudaUtils/utils.h"





using namespace cv;


// class hdTimer
// {
// public:
//     hdTimer()
//     {
//         QueryPerformanceFrequency(&freq);
//     }
//     void tik()
//     {
//         QueryPerformanceCounter(&start);
//     }
//     void tok()
//     {
//         QueryPerformanceCounter(&end);
//     }
//     double cost()
//     {
//         return double(end.QuadPart - start.QuadPart) / double(freq.QuadPart);
//     }
//
// private:
//     LARGE_INTEGER start, end;
//     LARGE_INTEGER freq;
//
//
// };



int main()
{
    Mat src = imread("D:/opencv/samples/data/lena.jpg");

    Mat dst = Mat(src.rows, src.cols, src.type());
    dst.data = (unsigned char*)malloc(3 * src.rows * src.cols);
    

    ::utils::hdTimer* t0 = new ::utils::hdTimer();
    t0->tik();
    mycu::bilateralFilter(src, dst, 6, 12, 25);
    t0->tok();

    Mat bila;
    ::utils::hdTimer* t1 = new ::utils::hdTimer();
    t1->tik();
    bilateralFilter(src, bila, 9, 12, 25);
    t1->tok();

    std::cout << "\n\n\nt0.cost " << t0->cost() << " t1.cost " << t1->cost() <<"\n\n\n" << std::endl;
    while(true)
    {
        imshow("src", src);
        imshow("dst", dst);
        imshow("bila", bila);
        if(waitKey(20)=='q')
        {
            break;
        }
    }
    free(dst.data);
    dst.release();
    src.release();

    return 0;
}

